<template>
  <div
    class="autocomplete fr-input-group"
    :class="{ 'fr-input-group--error': validationError }"
  >
    <label
      class="fr-label"
      :for="name"
    >
      {{ displayLabel }}
    </label>
    <input
      :id="name"
      ref="combobox"
      v-model="modelValue"
      class="fr-input"
      :class="{ 'fr-input--error': validationError }"
      :name="name"
      autocomplete="off"
      :required="required"
      aria-autocomplete="list"
      aria-haspopup="listbox"
      aria-expanded="false"
      :aria-controls="listboxId"
      :aria-describedby="ariaDescribedby"
      :aria-activedescendant="activeOptionValue"
      role="combobox"
      @input="onSearch"
      @invalid="onValidate"
      @focus="isFocused = true"
      @keydown="onInputKeyDown"
    />
    <div
      v-if="validationError"
      :id="errorId"
      class="fr-messages-group"
      aria-live="assertive"
    >
      <p class="fr-message fr-message--error">
        {{ validationError }}
      </p>
    </div>

    <ul
      v-show="expanded"
      :id="listboxId"
      ref="listbox"
      class="menu"
      role="listbox"
    >
      <AtomLoader
        v-show="timeout"
        class="fr-mx-auto fr-my-5v"
      />
      <li
        v-for="([resultValue, resultLabel], index) in results"
        v-show="!timeout && !error"
        :ref="el => setOptionRef(el, resultValue)"
        :key="resultValue"
        class="menu-item"
        :class="{ 'active-menu-item': index === activeIndex }"
        role="option"
        :aria-selected="modelValue === resultValue"
        @mousedown="onOptionMouseDown"
        @click="onSelectOption(resultValue, index)"
      >
        {{ resultLabel }}
      </li>
      <AtomAlert
        v-if="error"
        :alert-type="AlertType.Error"
        :message="error"
      />
    </ul>
  </div>
</template>

<script lang="ts" setup>
  import { ComponentPublicInstance, Ref } from 'vue'
  import { UNKNOWN_ERROR_MESSAGE } from '~/utils/constants'
  import { AlertType } from '~/utils/constants/alert'

  const props = withDefaults(
    defineProps<{
      label: string
      name: string
      searchFn: (search: string) => Promise<Map<string, string>>
      value?: string
      required?: boolean
    }>(),
    { value: '', required: false }
  )

  const emit = defineEmits<{
    (e: 'resultSelected', value: string): void
  }>()

  const results = ref<Map<string, string>>(new Map())
  const timeout = ref<NodeJS.Timeout | null>(null)
  const error = ref<string>('')
  const modelValue = ref<string>(props.value)
  const validationError = ref<string>('')
  const combobox = ref<HTMLInputElement | null>(null)

  const optionRefs: { [key: string]: Ref<HTMLElement | null> } = {}

  const resultValues = computed(() => [...results.value.keys()])

  const {
    /**
     * For dropdown mode, indicates whether the listbox is expanded or not
     */
    expanded: isFocused,

    /**
     * Prevent from closing the listbox on blur
     * It is used when an option is clicked
     */
    ignoreBlur,

    /**
     * The active option index in the options list
     */
    activeIndex,
    activeOptionValue,
    listbox,

    /**
     * Flag to set focus on next render completion, when menu was blurred on click on option
     */
    callFocus
  } = useExpandMenu(combobox, resultValues, optionRefs)

  const expanded = computed(
    () => !!(isFocused.value && (results.value.size || timeout.value))
  )

  const displayLabel = computed(() =>
    props.required ? `${props.label} *` : props.label
  )

  const errorId = computed(() => `autocomplete-${props.name}-error-desc-error`)

  const ariaDescribedby = computed(() =>
    error.value ? errorId.value : undefined
  )

  const listboxId = computed(() => `autocomplete-${props.name}-listbox`)

  watch(
    () => props.value,
    value => {
      modelValue.value = value
      results.value = new Map()
    }
  )

  watch(expanded, _expanded => {
    // As Vue2 removes attribute when set to a falsy value, it can not directly binded in the template
    combobox.value?.setAttribute('aria-expanded', _expanded.toString())
  })

  function onSearch(event: Event) {
    const input = event.target as HTMLInputElement
    validationError.value = ''
    const search = input.value.trim().toLocaleLowerCase()

    if (timeout.value) {
      clearTimeout(timeout.value)
      timeout.value = null
    }
    results.value = new Map()
    error.value = ''

    if (!search) return

    timeout.value = setTimeout(async () => {
      try {
        results.value = await props.searchFn(search)
      } catch {
        error.value = UNKNOWN_ERROR_MESSAGE
      } finally {
        timeout.value = null
      }
    }, 400)
  }

  function onValidate(event: Event) {
    const input = event.target as HTMLInputElement
    validationError.value = input.validationMessage
  }

  function onOptionMouseDown() {
    ignoreBlur.value = true
    callFocus.value = true
  }

  function onInputKeyDown(e: KeyboardEvent) {
    if (!expanded.value) {
      if (e.key !== 'Escape') isFocused.value = true
      return
    }

    // Keyboard interactions on the expanded listbox
    if (e.key === 'Enter') onSelectOption(activeOptionValue.value)
  }

  /**
   * Set an option value as the selected value
   * @param value The option value to select
   * @param optionIndex Optional - The option index to set as active when selecting from mouse click
   */
  function onSelectOption(optionValue: string, optionIndex?: number) {
    if (optionIndex) activeIndex.value = optionIndex
    modelValue.value = results.value.get(optionValue) || ''
    emit('resultSelected', optionValue)
  }

  function setOptionRef(
    el: Element | ComponentPublicInstance | null,
    optionValue: string
  ) {
    if (optionRefs[optionValue]) {
      optionRefs[optionValue].value = el as HTMLElement
    } else optionRefs[optionValue] = ref(el as HTMLElement)
  }
</script>
